Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 74914)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 74915)
@@ -1769,5 +1769,5 @@
 
     /* Which VM we are loading: */
-    LogRelFlow(("UIChooserModel: Loading VM with ID={%s}...\n", machine.GetId().toString().toUtf8().constData()));
+    LogRelFlow(("UIChooserModel: Loading VM with ID={%s}...\n", toOldStyleUuid(machine.GetId()).toUtf8().constData()));
     /* Is that machine accessible? */
     if (machine.GetAccessible())
@@ -1793,5 +1793,5 @@
         }
         /* Update group definitions: */
-        m_groups[machine.GetId().toString()] = groupList;
+        m_groups[toOldStyleUuid(machine.GetId())] = groupList;
     }
     /* Inaccessible machine: */
@@ -1799,5 +1799,5 @@
     {
         /* VM is accessible: */
-        LogRelFlow(("UIChooserModel:  VM {%s} is inaccessible.\n", machine.GetId().toString().toUtf8().constData()));
+        LogRelFlow(("UIChooserModel:  VM {%s} is inaccessible.\n", toOldStyleUuid(machine.GetId()).toUtf8().constData()));
         /* Create machine-item with main-root group-item as parent: */
         createMachineItem(machine, mainRoot());
@@ -1911,5 +1911,5 @@
             /* Which position should be current item placed by definitions? */
             QString strDefinitionName = pItem->type() == UIChooserItemType_Group ? pItem->name() :
-                                        pItem->type() == UIChooserItemType_Machine ? pItem->toMachineItem()->id().toString() :
+                                        pItem->type() == UIChooserItemType_Machine ? toOldStyleUuid(pItem->toMachineItem()->id()) :
                                         QString();
             AssertMsg(!strDefinitionName.isEmpty(), ("Wrong definition name!"));
@@ -1978,5 +1978,5 @@
 {
     /* Create machine-item: */
-    new UIChooserItemMachine(pParentItem, machine, getDesiredPosition(pParentItem, UIChooserItemType_Machine, machine.GetId().toString()));
+    new UIChooserItemMachine(pParentItem, machine, getDesiredPosition(pParentItem, UIChooserItemType_Machine, toOldStyleUuid(machine.GetId())));
 }
 
@@ -2160,5 +2160,5 @@
         if (UIChooserItemMachine *pMachineItem = pItem->toMachineItem())
             if (pMachineItem->accessible())
-                definitions[pMachineItem->id().toString()] << pParentGroup->fullName();
+                definitions[toOldStyleUuid(pMachineItem->id())] << pParentGroup->fullName();
     /* Iterate over all the group-items: */
     foreach (UIChooserItem *pItem, pParentGroup->items(UIChooserItemType_Group))
@@ -2180,5 +2180,5 @@
     /* Iterate over all the machine-items: */
     foreach (UIChooserItem *pItem, pParentItem->items(UIChooserItemType_Machine))
-        orders[strExtraDataKey] << QString("m=%1").arg(pItem->toMachineItem()->id().toString());
+        orders[strExtraDataKey] << QString("m=%1").arg(toOldStyleUuid(pItem->toMachineItem()->id()));
 }
 
@@ -2195,4 +2195,10 @@
     if (UIThreadGroupOrderSave::instance())
         UIThreadGroupOrderSave::cleanup();
+}
+
+/* static */
+QString UIChooserModel::toOldStyleUuid(const QUuid &uId)
+{
+    return uId.toString().remove(QRegExp("[{}]"));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 74914)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 74915)
@@ -456,4 +456,8 @@
         /** Makes sure group orders saving is finished. */
         void makeSureGroupOrdersSaveIsFinished();
+
+        /** Returns QString representation for passed @a uId, wiping out {} symbols.
+          * @note  Required for backward compatibility after QString=>QUuid change. */
+        static QString toOldStyleUuid(const QUuid &uId);
     /** @} */
 