Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 75059)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 75060)
@@ -123,4 +123,5 @@
         <file alias="expanding_collapsing_16px.png">images/expanding_collapsing_16px.png</file>
         <file alias="export_16px.png">images/export_16px.png</file>
+        <file alias="export_32px.png">images/export_32px.png</file>
         <file alias="extension_pack_16px.png">images/extension_pack_16px.png</file>
         <file alias="extension_pack_24px.png">images/extension_pack_24px.png</file>
@@ -171,4 +172,5 @@
         <file alias="fullscreen_on_disabled_16px.png">images/fullscreen_on_disabled_16px.png</file>
         <file alias="global_settings_16px.png">images/global_settings_16px.png</file>
+        <file alias="global_settings_32px.png">images/global_settings_32px.png</file>
         <file alias="group_abstract_16px.png">images/group_abstract_16px.png</file>
         <file alias="guesttools_16px.png">images/guesttools_16px.png</file>
@@ -242,4 +244,5 @@
         <file alias="ide_expand_16px.png">images/ide_expand_16px.png</file>
         <file alias="import_16px.png">images/import_16px.png</file>
+        <file alias="import_32px.png">images/import_32px.png</file>
         <file alias="interface_16px.png">images/interface_16px.png</file>
         <file alias="interface_24px.png">images/interface_24px.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 75059)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 75060)
@@ -123,4 +123,5 @@
         <file alias="expanding_collapsing_16px_x2.png">images/x2/expanding_collapsing_16px_x2.png</file>
         <file alias="export_16px_x2.png">images/x2/export_16px_x2.png</file>
+        <file alias="export_32px_x2.png">images/x2/export_32px_x2.png</file>
         <file alias="extension_pack_16px_x2.png">images/x2/extension_pack_16px_x2.png</file>
         <file alias="extension_pack_24px_x2.png">images/x2/extension_pack_24px_x2.png</file>
@@ -171,4 +172,5 @@
         <file alias="fullscreen_on_disabled_16px_x2.png">images/x2/fullscreen_on_disabled_16px_x2.png</file>
         <file alias="global_settings_16px_x2.png">images/x2/global_settings_16px_x2.png</file>
+        <file alias="global_settings_32px_x2.png">images/x2/global_settings_32px_x2.png</file>
         <file alias="group_abstract_16px_x2.png">images/x2/group_abstract_16px_x2.png</file>
         <file alias="guesttools_16px_x2.png">images/x2/guesttools_16px_x2.png</file>
@@ -238,4 +240,5 @@
         <file alias="ide_expand_16px_x2.png">images/x2/ide_expand_16px_x2.png</file>
         <file alias="import_16px_x2.png">images/x2/import_16px_x2.png</file>
+        <file alias="import_32px_x2.png">images/x2/import_32px_x2.png</file>
         <file alias="interface_16px_x2.png">images/x2/interface_16px_x2.png</file>
         <file alias="interface_24px_x2.png">images/x2/interface_24px_x2.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 75059)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 75060)
@@ -241,4 +241,5 @@
         <file alias="virtual_screen_disabled_16px.png">images/virtual_screen_disabled_16px.png</file>
         <file alias="vm_add_16px.png">images/vm_add_16px.png</file>
+        <file alias="vm_add_32px.png">images/vm_add_32px.png</file>
         <file alias="vm_clone_16px.png">images/vm_clone_16px.png</file>
         <file alias="vm_clone_32px.png">images/vm_clone_32px.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc	(revision 75059)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc	(revision 75060)
@@ -243,4 +243,5 @@
         <file alias="virtual_screen_disabled_16px_x2.png">images/x2/virtual_screen_disabled_16px_x2.png</file>
         <file alias="vm_add_16px_x2.png">images/x2/vm_add_16px_x2.png</file>
+        <file alias="vm_add_32px_x2.png">images/x2/vm_add_32px_x2.png</file>
         <file alias="vm_clone_16px_x2.png">images/x2/vm_clone_16px_x2.png</file>
         <file alias="vm_clone_32px_x2.png">images/x2/vm_clone_32px_x2.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 75059)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 75060)
@@ -1133,5 +1133,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimplePreferences(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/global_settings_16px.png", ":/global_settings_16px.png", true)
+        : UIActionSimple(pParent, ":/global_settings_32px.png", ":/global_settings_16px.png", true)
     {
         setMenuRole(QAction::PreferencesRole);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp	(revision 75059)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp	(revision 75060)
@@ -174,5 +174,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleSelectorFileShowImportApplianceWizard(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/import_16px.png", ":/import_16px.png")
+        : UIActionSimple(pParent, ":/import_32px.png", ":/import_16px.png")
     {}
 
@@ -211,5 +211,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleSelectorFileShowExportApplianceWizard(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/export_16px.png", ":/export_16px.png")
+        : UIActionSimple(pParent, ":/export_32px.png", ":/export_16px.png")
     {}
 
@@ -378,5 +378,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleSelectorGroupPerformAddMachine(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_add_16px.png", ":/vm_add_16px.png")
+        : UIActionSimple(pParent, ":/vm_add_32px.png", ":/vm_add_16px.png")
     {}
 
@@ -566,5 +566,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleSelectorMachinePerformAdd(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_add_16px.png", ":/vm_add_16px.png")
+        : UIActionSimple(pParent, ":/vm_add_32px.png", ":/vm_add_16px.png")
     {}
 