Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 75105)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 75106)
@@ -130,5 +130,5 @@
 }
 
-bool UIChooserItemGlobal::isToolsButtonArea(const QPoint &position) const
+bool UIChooserItemGlobal::isToolsButtonArea(const QPoint &position, int iMarginMultiplier /* = 1 */) const
 {
     const int iFullWidth = geometry().width();
@@ -142,5 +142,6 @@
                        m_toolsPixmap.width() / m_toolsPixmap.devicePixelRatio(),
                        m_toolsPixmap.height() / m_toolsPixmap.devicePixelRatio());
-    rect.adjust(- iButtonMargin, -iButtonMargin, iButtonMargin, iButtonMargin);
+    rect.adjust(-iMarginMultiplier * iButtonMargin, -iMarginMultiplier * iButtonMargin,
+                 iMarginMultiplier * iButtonMargin,  iMarginMultiplier * iButtonMargin);
     return rect.contains(position);
 }
@@ -803,10 +804,12 @@
 
         /* Paint flat button: */
-        paintFlatButton(/* Painter: */
-                        pPainter,
-                        /* Button rectangle: */
-                        buttonRectangle,
-                        /* Cursor position: */
-                        itemCursorPosition);
+        if (   isHovered()
+            && isToolsButtonArea(itemCursorPosition, 4))
+            paintFlatButton(/* Painter: */
+                            pPainter,
+                            /* Button rectangle: */
+                            buttonRectangle,
+                            /* Cursor position: */
+                            itemCursorPosition);
 
         /* Paint pixmap: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 75105)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 75106)
@@ -49,5 +49,5 @@
       * @{ */
         /** Returns whether passed @a position belongs to tools button area. */
-        bool isToolsButtonArea(const QPoint &position) const;
+        bool isToolsButtonArea(const QPoint &position, int iMarginMultiplier = 1) const;
     /** @} */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 75105)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 75106)
@@ -163,5 +163,5 @@
 }
 
-bool UIChooserItemMachine::isToolsButtonArea(const QPoint &position) const
+bool UIChooserItemMachine::isToolsButtonArea(const QPoint &position, int iMarginMultiplier /* = 1 */) const
 {
     const int iFullWidth = geometry().width();
@@ -175,5 +175,6 @@
                        m_toolsPixmap.width() / m_toolsPixmap.devicePixelRatio(),
                        m_toolsPixmap.height() / m_toolsPixmap.devicePixelRatio());
-    rect.adjust(- iButtonMargin, -iButtonMargin, iButtonMargin, iButtonMargin);
+    rect.adjust(-iMarginMultiplier * iButtonMargin, -iMarginMultiplier * iButtonMargin,
+                 iMarginMultiplier * iButtonMargin,  iMarginMultiplier * iButtonMargin);
     return rect.contains(position);
 }
@@ -1264,10 +1265,12 @@
 
         /* Paint flat button: */
-        paintFlatButton(/* Painter: */
-                        pPainter,
-                        /* Button rectangle: */
-                        buttonRectangle,
-                        /* Cursor position: */
-                        itemCursorPosition);
+        if (   isHovered()
+            && isToolsButtonArea(itemCursorPosition, 4))
+            paintFlatButton(/* Painter: */
+                            pPainter,
+                            /* Button rectangle: */
+                            buttonRectangle,
+                            /* Cursor position: */
+                            itemCursorPosition);
 
         /* Paint pixmap: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 75105)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 75106)
@@ -62,5 +62,5 @@
 
         /** Returns whether passed @a position belongs to tools button area. */
-        bool isToolsButtonArea(const QPoint &position) const;
+        bool isToolsButtonArea(const QPoint &position, int iMarginMultiplier = 1) const;
     /** @} */
 