Index: trunk/src/VBox/Runtime/r0drv/os2/memobj-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/memobj-r0drv-os2.cpp	(revision 75130)
+++ trunk/src/VBox/Runtime/r0drv/os2/memobj-r0drv-os2.cpp	(revision 75133)
@@ -80,5 +80,4 @@
             AssertMsgFailed(("RTR0MEMOBJTYPE_PHYS_NC\n"));
             return VERR_INTERNAL_ERROR;
-            break;
 
         case RTR0MEMOBJTYPE_PHYS:
@@ -309,4 +308,5 @@
 DECLHIDDEN(int) rtR0MemObjNativeReserveKernel(PPRTR0MEMOBJINTERNAL ppMem, void *pvFixed, size_t cb, size_t uAlignment)
 {
+    RT_NOREF(ppMem, pvFixed, cb, uAlignment);
     return VERR_NOT_SUPPORTED;
 }
@@ -316,4 +316,5 @@
                                             RTR0PROCESS R0Process)
 {
+    RT_NOREF(ppMem, R3PtrFixed, cb, uAlignment, R0Process);
     return VERR_NOT_SUPPORTED;
 }
@@ -356,5 +357,6 @@
                 AssertMsgReturn(fProt & RTMEM_PROT_WRITE, ("%#x\n", fProt), VERR_NOT_SUPPORTED);
                 Assert(!pMemToMapOs2->Core.u.Phys.fAllocated);
-                ULONG ulPhys = pMemToMapOs2->Core.u.Phys.PhysBase;
+                ULONG ulPhys = (ULONG)pMemToMapOs2->Core.u.Phys.PhysBase;
+                AssertReturn(ulPhys == pMemToMapOs2->Core.u.Phys.PhysBase, VERR_OUT_OF_RANGE);
                 rc = KernVMAlloc(pMemToMapOs2->Core.cb, VMDHA_PHYS, &pvR0, (PPVOID)&ulPhys, NULL);
                 if (rc)
@@ -367,5 +369,4 @@
             AssertMsgFailed(("RTR0MEMOBJTYPE_PHYS_NC\n"));
             return VERR_INTERNAL_ERROR_3;
-            break;
 
         case RTR0MEMOBJTYPE_LOCK:
@@ -444,5 +445,4 @@
             AssertMsgFailed(("RTR0MEMOBJTYPE_PHYS_NC\n"));
             return VERR_INTERNAL_ERROR_5;
-            break;
 
         case RTR0MEMOBJTYPE_LOCK:
Index: trunk/src/VBox/Runtime/r0drv/os2/memuserkernel-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/memuserkernel-r0drv-os2.cpp	(revision 75130)
+++ trunk/src/VBox/Runtime/r0drv/os2/memuserkernel-r0drv-os2.cpp	(revision 75133)
@@ -79,4 +79,5 @@
 RTR0DECL(int) RTR0MemKernelCopyFrom(void *pvDst, void const *pvSrc, size_t cb)
 {
+    RT_NOREF(pvDst, pvSrc, cb);
     return VERR_NOT_SUPPORTED;
 }
@@ -85,4 +86,5 @@
 RTR0DECL(int) RTR0MemKernelCopyTo(void *pvDst, void const *pvSrc, size_t cb)
 {
+    RT_NOREF(pvDst, pvSrc, cb);
     return VERR_NOT_SUPPORTED;
 }
Index: trunk/src/VBox/Runtime/r0drv/os2/semeventmulti-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/semeventmulti-r0drv-os2.cpp	(revision 75130)
+++ trunk/src/VBox/Runtime/r0drv/os2/semeventmulti-r0drv-os2.cpp	(revision 75133)
@@ -91,4 +91,5 @@
         return VINF_SUCCESS;
     }
+    RT_NOREF(hClass, pszNameFmt);
     return VERR_NO_MEMORY;
 }
@@ -178,4 +179,6 @@
                                     PCRTLOCKVALSRCPOS pSrcPos)
 {
+    RT_NOREF(pSrcPos);
+
     /*
      * Validate and convert the input.
Index: trunk/src/VBox/Runtime/r0drv/os2/spinlock-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/spinlock-r0drv-os2.cpp	(revision 75130)
+++ trunk/src/VBox/Runtime/r0drv/os2/spinlock-r0drv-os2.cpp	(revision 75133)
@@ -67,4 +67,5 @@
 {
     AssertReturn(fFlags == RTSPINLOCK_FLAGS_INTERRUPT_SAFE || fFlags == RTSPINLOCK_FLAGS_INTERRUPT_UNSAFE, VERR_INVALID_PARAMETER);
+    RT_NOREF(pszName);
 
     /*
Index: trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp	(revision 75130)
+++ trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp	(revision 75133)
@@ -289,5 +289,5 @@
     if (!rtTimerIsValid(pTimer))
         return VERR_INVALID_HANDLE;
-
+    RT_NOREF(u64NanoInterval);
     return VERR_NOT_SUPPORTED;
 }
@@ -367,4 +367,5 @@
 RTDECL(int) RTTimerRequestSystemGranularity(uint32_t u32Request, uint32_t *pu32Granted)
 {
+    RT_NOREF(u32Request, pu32Granted);
     return VERR_NOT_SUPPORTED;
 }
@@ -373,4 +374,5 @@
 RTDECL(int) RTTimerReleaseSystemGranularity(uint32_t u32Granted)
 {
+    RT_NOREF(u32Granted);
     return VERR_NOT_SUPPORTED;
 }